<template>
  <div class="row">
    <strong class="q-mb-sm">{{ title }}</strong>
    <div class="col-12">
      <q-input
        clearable outlined
        :readonly="readonly"
        label="Filtrer" square
        v-model="searchText"
        @input="onSearching"
        dense
      >
        <template v-slot:append>
          <q-icon
            :name="'la la-filter'"
            class="cursor-pointer"
            color="blue-grey-3"
          />
        </template>
      </q-input>
    </div>
    <q-card class="q-mt-sm col-12" style="overflow-y: scroll; max-height: 500px;" flat square bordered >
      <draggable
        style="border: 1px solid #cecbcb; min-height: 35px;"
        :disabled="mode === 'view'"
        :list="listFiltered" group="people" @change="onChange">
        <slot name="drag-list" v-bind="listFiltered">
          <q-item
            dense style="border: 1px solid #cdc9c9"
            v-for="(element, index) in listFiltered"
            :key="index"
          >
            <slot name="drag-item" v-bind="element">
              <q-item-section>
                <q-item-label>
                  <q-checkbox
                    :disable="mode === 'view'"
                    @input="onSelect(element,$event)"
                    :value="isSelected(element)"
                    :label="element[labelAttr]"
                    :name="element[nameAttr]+''"
                  />
                </q-item-label>
              </q-item-section>
            </slot>
          </q-item>
        </slot>
      </draggable>
    </q-card>
  </div>
</template>

<script>
import draggable from 'vuedraggable'
import MField from "components/forms/MField";
import debounce from "lodash/debounce";
import ModeMixin from 'src/mixins/mode-mixin'

export default {
  name: 'QDraggable',
  mixins: [ModeMixin],
  components: {MField, draggable},

  props: {
    title: {
      type: String,
    },

    value: {
      type: Array,
    },
    labelAttr: {
      type: String,
      default: 'name'
    },
    selected:{
      type: Array,
      default: () =>[]
    },
    nameAttr: {
      type: String,
      default: 'slug'
    },
  },

  data() {
    return {
      items: [],
      selectedValues: [],
      search: '',
      searchText: '',
      onSearching: null
    }
  },

  mounted() {
    this.onSearching = debounce(() => this.search = this.searchText, 1000);
  },


  methods: {
    onChange(event){
      const [[ev, data]] = Object.entries(event);
      switch(ev){
        case 'added':
          this.onAdd(data);
          break;
        case 'removed':
          this.onRemove(data);
          break;
        case 'moved':
          this.onMove(data);
          break;
      }

    },
    isEqual(element) {
      return (row) => {
        return element[this.nameAttr] === row[this.nameAttr]
      }
    },
    isNotEqual(element) {
      return (row) => {
        return element[this.nameAttr] !== row[this.nameAttr]
      }
    },
    isSelected(element) {
      return this.selectedValues.some(this.isEqual(element));
    },
    filterList(element){
      return (element[this.labelAttr] || '').toLowerCase().indexOf(this.search||'') > -1
    },
    onSelect(element, status){
      if(status)
        this.selectedValues = [...this.selectedValues,element];
      else
        this.selectedValues = this.selectedValues.filter(this.isNotEqual(element));

      this.$emit('update:selected', this.selectedValues);
    },
    onAdd({element,newIndex}){
      const data = [...this.value];
      data.splice(newIndex,0,element)
      this.$emit('input',data);
    },
    onRemove({element,oldIndex}){
      const data = [...this.value]
      data.splice(oldIndex,1);
      this.selectedValues = this.selectedValues.filter(this.isNotEqual(element));
      this.$emit('input',data);
    },
    onMove({element,newIndex,oldIndex}){
      const data = [...this.value];
      data.splice(oldIndex,1);
      data.splice(newIndex,0, element);
      this.$emit('input',data);
    }
  },

  computed: {
    listFiltered() {
     return this.value.filter(this.filterList)
    },
    readonly(){
      return Array.isArray(this.value) ? this.value.length  < 1 : true
    }
  },

  watch: {
    selected:{
      handler: function (newValue, oldValue) {
        this.selectedValues = newValue;
      },
      deep: true,
      immediate: true,
    }
  },

}
</script>

